/* A program that updates a sorted filelist of CDs by processing a */
/* another sorted list of insertion and deletion transactions.     */

/* Author: Zach Tomaszewski */
/* Date:   01 May 2003      */

#include "updlist.hpp"


int main(int argc, char* argv[]) {

  string masterfilename, transfilename, outfilename;

  //get filenames
  switch (argc) {
  case (4): 
    masterfilename = argv[1];
    transfilename = argv[2];
    outfilename = argv[3];
    break;
  case (3):
    masterfilename = argv[1];
    transfilename = argv[2];
    break;
  default:
    cout << "This file updates a masterlist ";
    cout << "by prcocessing a transaction list." << endl;
    cout << "Enter masterlist filename: ";
    cin >> masterfilename;
    cout << "Enter transaction list filename: ";
    cin >> transfilename;
    cout << "Enter output filename for new masterlist ";
    cout << "(enter 0 for none): ";
    cin >> outfilename;
  }

  //open files
  ifstream masterfile(masterfilename.c_str());
  if (!masterfile){
    cout << "Could not open masterlist file: "; 
    cout << masterfilename << endl;
    return(1);
  }
  ifstream transfile(transfilename.c_str());
  if (!transfile){
    cout << "Could not open transaction list file: ";
    cout << masterfilename << endl;
    return(1);
  }
  ofstream outfile;
  if (outfilename.length() > 0 && outfilename != "0"){
    ofstream outfile(outfilename.c_str());
    if (!outfile){
      cout << "Could not open output file: ";
      cout << outfilename << endl;
      return(1);
    }
  }

  KEYEDLIST out = runTransactions(masterfile, transfile, 3);

  if (outfile){
    printKeyedList(out, outfile); //fix
    outfile.close();
  }
  return(0);
}
